Package: MPFE
Type: Package
Title: Estimation of the amplicon methylation pattern distribution from
        bisulphite sequencing data
Version: 1.47.0
Date: 2014-11-28
Author: Peijie Lin, Sylvain Foret, Conrad Burden
biocViews: HighThroughputSequencingData, DNAMethylation, MethylSeq
Maintainer: Conrad Burden <conrad.burden@anu.edu.au>
Description: Estimate distribution of methylation patterns from a table of counts from a bisulphite sequencing experiment given a non-conversion rate and read error rate.
License: GPL (>= 3)
git_url: https://git.bioconductor.org/packages/MPFE
git_branch: devel
git_last_commit: 8e3d15d
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-30
NeedsCompilation: no
Packaged: 2025-10-30 22:03:43 UTC; biocbuild

MPFE
=====

Estimate distribution of methylation patterns from a table of counts from a
bisulphite sequencing experiment given a non-conversion rate and read error
rate.

See DESCRIPTION and the documentation in man/ for more information.

plotPatterns <- function(compareData,
                         yLimit1=NULL,
                         yLimit2=NULL)
{
      if(class(compareData) != "data.frame") {
        stop("compareData must be a data.frame")
      }
      if(is.null(yLimit1)) {
        yLimit1 <- ceiling(max(compareData$observedDistribution, compareData$estimatedDistribution) * 10.2) / 10
      }
      if(is.null(yLimit2)) {
        yLimit2 <- quantile(sort(compareData$observedDistribution), 0.9)
      }

      layout(matrix(c(1, 2, 3), 3, 1, byrow=TRUE), heights=c(5, 1, 5))

      par(mar=c(5.4, 5, 2, 5))
      plot(compareData$estimatedDistribution,
           pch=4,
           col='white',
           xlab='pattern',
           ylab='proportion',
           cex.lab=1.5,
           ylim=c(0, yLimit1))
      points(compareData$estimatedDistribution, pch=4, col='red')
      par(new=TRUE)
      plot(compareData$coverage,
           col='blue',
           pch=3,
           xlab='',
           ylab='',
           ylim=c(0, sum(compareData$coverage) * yLimit1),
           axes=FALSE)
      axis(side=4)
      mtext('coverage', side=4, line=2.5)
      abline(0, 0, col='grey')

      par(mar=c(0, 0, 0, 5))
      plot.new()
      legend('right', c('observed distribution','estimated distribution'), pch=c(3,4), col=c('BLUE', 'RED'))

      par(mar=c(5.4, 5, 2, 5))
      plot(compareData$estimatedDistribution,
           pch=4,
           col='white',
           xlab='pattern',
           ylab='proportion',
           cex.lab=1.5,
           ylim=c(0, yLimit2))
      points(compareData$estimatedDistribution, pch=4, col='red')
      par(new=TRUE)
      plot(compareData$coverage,
           col='blue',
           pch=3,
           xlab='',
           ylab='',
           ylim=c(0,sum(compareData$coverage) * yLimit2),
           axes=FALSE)
      axis(side=4, at=c(compareData$coverage, 0, 10))
      mtext('coverage', side=4, line=2.5)
      abline(0, 0, col='grey')
}

# vim:ft=r:ts=4:sw=4:sts=4:expandtab:

estimatePatterns <- function(patternCounts,
                             epsilon=0,
                             eta=0,
                             column=NULL,
                             fast=TRUE,
                             steps=20000,
                             reltol=1e-12)
{
    # Check the patterns
    # First, strip any leading character different from 01
    patterns <- gsub('[^01]', '', as.character(patternCounts[, 1]))
    # Make sure we only have zeros and ones:
    matches <- grep('[01]+', patterns, invert=TRUE)
    if (length(matches) > 0) {
        stop('Only 0s and 1s allowed in pattern. First (up to ten) offending patterns:', head(patterns[matches], 10), '\n')
    }
    # Make sure that all patterns have the same length
    nCpGsites <- nchar(patterns[1])
    if (any(nchar(patterns) != nCpGsites)) {
        stop('All patterns must be the same length\n')
    }

    patternCounts[, 1] <- patterns
    # Check Epsilon
    if (!is.numeric(epsilon) || epsilon < 0 || epsilon >= 1) {
        stop('epsilon must be a numeric between 0 and 1\n')
    }

    # Check Eta
    nEtas <- length(eta)
    if (nEtas != 1 && nEtas != nCpGsites) {
        stop('Length of eta is not equal to the number of CpG sites\n')
    } else if (!is.numeric(eta) || any(eta < 0) || any(eta >= 1)) {
        stop('eta must be a numeric between 0 and 1\n')
    }

    # Check the column indices
    nColumns <- ncol(patternCounts) - 1
    if (is.null(column)) {
        columns <- 1:nColumns
    } else {
        columns <- column
    }
    if (any(columns < 1) || any(columns > nColumns)) {
        stop('Column indices must be between 1 and ', nColumns, '\n')
    }

    compareData <- list()
    for (i in 1:length(columns)) {
        compareData[[i]] <- estimatePatternsOneColumn(patternCounts,
                                                      epsilon,
                                                      eta,
                                                      column=columns[i],
                                                      fast,
                                                      steps,
                                                      reltol)
    }

    return(compareData)
}

estimatePatternsOneColumn <- function(patternCounts,
                                      epsilon,
                                      eta,
                                      column,
                                      fast,
                                      steps,
                                      reltol)
{
    patternCounts <- patternCounts[, c(1, column + 1)]
    names(patternCounts) <- c('patterns','counts')   
    patternCounts <- patternCounts[patternCounts$counts !=0, ]
    nCpGsites <- nchar(patternCounts$patterns[1])

    # Create the vector of patterns

    if (fast) {
        methData <- patternCounts
    } else {
            binary <- function(x) if (all(x < 2)) x else cbind(binary(x %/% 2), x %% 2)
            cytosineBinary <- binary(0:(2 ^ nCpGsites - 1))
            mPattern <- array(dim=c(2^nCpGsites, 1))
            for(i in 1:(2 ^ nCpGsites)) {
                mPattern[i, 1] <- paste(cytosineBinary[i, ], collapse='')
            }
            counts <- array(0, dim=c(2^nCpGsites,1))
            methData <- data.frame(patterns=mPattern, counts=counts)
            methData$patterns <- as.character(methData$patterns)
            for(i in 1:(2 ^ nCpGsites)) {
                patternMatches <- patternCounts$patterns == mPattern[i, 1]
                if(any(patternMatches)) {
                    methData[i, 2] <- patternCounts[patternMatches, 2]
                }
            }
    }

    yPatterns <- methData$counts
    totalPatterns <- sum(yPatterns)
    readDistribution <- yPatterns / totalPatterns
    patternsMax <- which.max(yPatterns)
    yWithoutMax <- yPatterns[-patternsMax]

    # Create the pattern array

    size <- nrow(methData)

     stringToVector <- function(x) {
         patternVector <- array(dim=nchar(x))
         for (i in 1:nchar(x)) {
             patternVector[i] <- as.numeric(substr(x, i, i))
         }
         return(patternVector)
     }

     patternArray <- array(dim=c(size, nCpGsites))

     for (i in 1:size) {
      patternArray[i, ] <- stringToVector(methData$patterns[i])
     }

     # Construct the conversion matrix

    if (fast) {
        conversionMatrix <- array(0, dim=c(size, size))
        for (i in 1:size) {
            for (j in 1:size) {
                fromIndex <- patternArray[i, ]
                toIndex <- patternArray[j, ]
                conversionMatrix[i, j] <- prod((1 - epsilon - eta + 2 * epsilon * eta) ^ ((fromIndex + toIndex == 0) * 1) *
                                               (epsilon + eta - 2 * epsilon * eta) ^ ((fromIndex - toIndex == -1) * 1) *
                                               eta ^ ((fromIndex - toIndex == 1) * 1) *
                                               (1 - eta) ^ ((fromIndex + toIndex == 2) * 1))
             }
        }
    } else {
        conversionRule <- list(array(0, dim=c(2, 2)))
        for (i in 1:nCpGsites) {
          conversionRule[[i]] <- array(c(1 - epsilon - eta[i] + 2 * epsilon * eta[i],
                                         eta[i],
                                         epsilon + eta[i]- 2 * epsilon * eta[i],
                                         1 - eta[i]),
                                       dim=c(2, 2))
        }
        conversionMatrix <- 1
        for (i in 1:nCpGsites) {
            conversionMatrix <- kronecker(conversionMatrix, conversionRule[[i]])
        }
    }


    # Define the likelihood function
    # Note that likelihoodOpt's argument has one less entry than the function likelihood

    likelihood <- function(theta) {
        phi <- theta %*% conversionMatrix
        if (fast) {
            lhd <- -sum(yPatterns * log(as.vector(phi)))
        } else {
            lhd <- -sum(yPatterns[yPatterns != 0] * log(phi[yPatterns != 0]))
        }
        return(lhd)
    }

    expand <- function(theta, patternsMax) {
        expanded <- c(theta[(1:length(theta)) < patternsMax],
                      1 - sum(theta),
                      theta[(1:length(theta)) >= patternsMax])
        return(expanded)
    }

    likelihoodOpt <- function(theta) {
        likelihoodOpted <- likelihood(expand(theta, patternsMax))
        return(likelihoodOpted)
    }
	
	likelihood_grad <- function(theta){
		theta2 <- expand(theta, patternsMax)
		phi <- as.vector(theta2 %*% conversionMatrix)
		
		if (fast) {
			likelihood_grad2 <- colSums(apply(conversionMatrix, 1, function(x) yPatterns*x/phi))
		} else {
			likelihood_grad2 <- colSums(apply(conversionMatrix, 1, 
											function(x) (yPatterns*x)[yPatterns !=0]/phi[yPatterns !=0]))
		}
		likelihood_grad <- -likelihood_grad2[-patternsMax]+sum(yPatterns*conversionMatrix[patternsMax,]/phi)
		return(likelihood_grad)
	}
	
		
    # Optimisation

    startingVector <- yWithoutMax / totalPatterns
    yZeros <- which(startingVector %in% c(0))
    startingVector[yZeros]<- yPatterns[patternsMax] / (100000 * totalPatterns)

    constraintMatrix <- rbind(diag(size - 1), rep(-1, size - 1))
    constraintVector <- append(rep(0, size - 1), -1)
    opt <- constrOptim(startingVector, likelihoodOpt, grad=likelihood_grad,
                        ui=constraintMatrix,
                        ci=constraintVector,
                        method='BFGS',
                        control=list(maxit=steps, reltol=reltol))

    recovered <- expand(opt$par, patternsMax)

    # Decide the "0's"

    minZeros <- recovered
    minLikelihood <- likelihood(recovered)
    listReduced <- 1:size

    for (i in listReduced[listReduced != patternsMax]) {
        minTemp <- minZeros
        minTemp[patternsMax] <- minTemp[patternsMax] + minTemp[i]
        minTemp[i] <- 0
        if(likelihood(minTemp) <= minLikelihood) {
            minZeros <- minTemp
            minLikelihood <- likelihood(minTemp)
        }
    }

    # Generate output

    compareData <- data.frame(pattern=methData$patterns,
                              coverage=yPatterns,
                              observedDistribution=readDistribution,
                              estimatedDistribution=minZeros)

    if(!fast) {
        compareData <- compareData[compareData$observedDistribution != 0 | compareData$estimatedDistribution != 0, ]
        rownames(compareData) <- 1:nrow(compareData)
    }

    if(opt$convergence!=0) {
        warning('Constrained optimisation did not converge.\n')
    }

    compareData$spurious <- compareData$observedDistribution !=0 & compareData$estimatedDistribution == 0

    return(compareData)
}

### R code from vignette source 'MPFE.Rnw'

###################################################
### code chunk number 1: MPFE.Rnw:52-56
###################################################
library(MPFE)
data(patternsExample)
patternsExample
estimatePatterns(patternsExample, epsilon=0.01, column=2)


###################################################
### code chunk number 2: MPFE.Rnw:66-70
###################################################
estimates <- estimatePatterns(patternsExample,
                              epsilon=0.01,
                              eta=c(0.008, 0.01, 0.01, 0.01, 0.008))
estimates


###################################################
### code chunk number 3: MPFE.Rnw:79-80
###################################################
plotPatterns(estimates[[2]])


###################################################
### code chunk number 4: MPFE.Rnw:89-109
###################################################
par(mfrow=c(2, 2))
patternMap(estimates[[1]],
           maxFreq=0.5,
           main='Estimated frequencies')
patternMap(estimates[[1]],
           estimatedDistribution=FALSE,
           maxFreq=0.5,
           topDown=FALSE,
           main='Observed frequencies')
patternMap(estimates[[1]],
           maxFreq=0.5,
           methCol=colorRampPalette(c('red', 'blue')),
           unMethCol='lightgrey',
           main='Estimated frequencies')
patternMap(estimates[[1]],
           estimatedDistribution=FALSE,
           maxFreq=0.5,
           methCol=c('bisque4', 'azure4'),
           unMethCol=c('beige', 'azure'),
           main='Observed frequencies')

patternMap <- function(patterns,
                       minFreq=0,
                       maxFreq=1,
                       noSpurious=TRUE,
                       estimatedDistribution=TRUE,
                       topDown=TRUE,
                       allTicks=FALSE,
                       methCol='black',
                       unMethCol='white',
                       ...)
{
    # If we use the estimated distribution, the spurious patterns are at zero
    if (estimatedDistribution)
    {
        noSpurious <- TRUE
    }
    # Remove the spurious patterns if necessary
    if (noSpurious)
    {
        patterns <- patterns[patterns$spurious == FALSE, ]
    }
    distOfInterest <- ifelse(estimatedDistribution,
                             'estimatedDistribution',
                             'observedDistribution')
    # Trim low frequencies
    patterns <- patterns[patterns[, distOfInterest] >= minFreq, ]
    # Trim high frequencies
    patterns <- patterns[patterns[, distOfInterest] <= maxFreq, ]
    # Number of patterns left
    nPatterns <- nrow(patterns)
    # Invert the list if necessary
    patterns <- patterns[order(patterns[, distOfInterest]), ]
    if (!topDown)
    {
        patterns <- patterns[nPatterns:1, ]
    }
    # Size of the patterns
    patternSize <- max(nchar(as.character(patterns$pattern)))
    # Compute the frequencies
    y0 <- sum(patterns[, distOfInterest])
    ys <- y0 - cumsum(patterns[, distOfInterest])

    # Colours

    # Auxilary function to create the colour vector
    getColours <- function(col)
    {
        if (is.function(col))
        {
            cols <- col(nPatterns)
        }
        else
        {
            return(rep(col, length=nPatterns))
        }
    }
    methCol <- getColours(methCol)
    unMethCol <- getColours(unMethCol)

    # Plot the main area
    plot(0,
         type="n",
         xlab="CpG",
         ylab="Proportion",
         xlim=c(0.5, patternSize + 0.5),
         #xaxp=c(1, patternSize, patternSize - 1), 
         ylim=c(0, y0),
         ...)

    # Add ticks for each CpG if required
    if (allTicks)
    {
        axis(1, at=1:patternSize, labels=FALSE)
    }

    # Draw the patterns
    for (i in 1:nPatterns)
    {
        patternString <- as.character(patterns$pattern[i])
        pattern       <- as.integer(strsplit(patternString, '')[[1]])
        freq          <- patterns[i, distOfInterest]
        x0            <- 0.5
        y1            <- ys[i]
        for (c in pattern)
        {
            colour <- ifelse(c == 1, methCol[i], unMethCol[i])
            x1     <- x0 + 1
            rect(x0, y1, x1, y0, col=colour, border='NA')
            x0     <- x1
        }
        y0 <- y1
    }
}

# vim:ft=r:ts=4:sw=4:sts=4:expandtab:

%\VignetteIndexEntry{MPFE}
%\VignetteDepends{MPFE}
%\VignettePackage{MPFE}

\documentclass[12pt]{article}

\usepackage{Sweave}

\textwidth=6.2in
\textheight=8.5in
\oddsidemargin=0.2in
\evensidemargin=0.2in
\headheight=0in
\headsep=0in

\begin{document}
\SweaveOpts{concordance=TRUE}

\title{MPFE}
\author{Conrad Burden, Sylvain For\^et, Peijie Lin}
\date{\today}
\maketitle

Many of the known mechanisms driving gene regulation fall into the category of epigenomic modifications.
DNA methylation is a common epigenomic modification, in which a cytosine (C) in the genomic DNA sequence can be altered by the addition of a methyl group.
Methylation patterns can be are detected by treating DNA with bisulphite, which converts unmethylated cytosines to uracils while leaving methylated cytosines intact.
This can be carried out at the whole genome level (whole-genome bisulfite sequencing) or at specific loci (PCR amplicons, capture or reduced representation bisulfite sequencing).
The resulting reads can be mapped to a reference and methylation patterns inferred.

However, the bisulphite conversion is not 100\% efficient, and this introduces errors in the observed distribution of methylation patterns.
A second source of errors is the sequencing error.
{\tt MPFE} (for \textbf{M}ethylation \textbf{P}atterns \textbf{F}requency \textbf{E}stimation)~\cite{Lin05} calculates the estimated distribution over methylation patterns based on an input of methylation pattern count data, an incomplete conversion rate and site-dependent read error rates.

The main component of the package is the function {\tt estimatePatterns()}, which generates a table of estimates $\hat\theta_i$ of the distribution over methylation patterns, and a list of patterns identified as spurious.
Input to the function is a data frame listing the methylation patterns in the first column followed by a number of columns of count data (one column per sample).
Estimation will be performed on all columns by default unless specified by the variable {\tt column}.
The non-conversion and sequencing error rates are specified by the parameters {\tt epsilon} and {\tt eta} respectively.
The parameter {\tt eta} can be specified globally or as a site-dependent array with length equal to the number of CpG sites in sequence of interest.
The boolean variable {\tt fast} enables either a fast implementation (default) which ignores those patterns for which the observed read count is zero or a slow implementation.
The parameters {\tt steps} and {\tt reltol} are passed to the function {\tt constrOptim()} to control the accuracy of the determination of the maximum log-likelihood.

A second function in the package is {\tt plotPatterns()}.
Input to this function is a data frame,
obtained from the output of {\tt estimatePatterns()}.
The output of {\tt plotPatterns()} is a plot that compares the observed read distribution with the estimated distribution.
The parameters {\tt yLimit1} and  {\tt yLimit2} control the range of the y-axis on the plots produced.

In the following example, the input is the table of counts {\tt patternsExample}.
We analyse the second column.
The parameter {\tt epsilon} is 0.01, while the parameter {\tt eta} is not specified and by default is 0.

<<>>=
library(MPFE)
data(patternsExample)
patternsExample
estimatePatterns(patternsExample, epsilon=0.01, column=2)
@

Note that in this example two patterns have been identified as spurious; they are patterns {\tt 01010} and {\tt 11000}.

The following example uses the same input table.
The {\tt column} variable is not specified,
so the function {\tt estimatePatterns()} by default applies to both columns of counts.
The sequencing error rate {\tt eta} is specified as a site-dependent array.

<<>>=
estimates <- estimatePatterns(patternsExample,
                              epsilon=0.01,
                              eta=c(0.008, 0.01, 0.01, 0.01, 0.008))
estimates
@

The ouput is a list of two data frames.
We plot the observed and estimated pattern of the second data frame on figure 1.
Two plots are produced: the lower plot is the expanded version of the upper plot.


\begin{figure}
<<fig=TRUE>>=
plotPatterns(estimates[[2]])
@
\caption{Plot of observed and estimated frequencies with \texttt{plotPatterns}}
\end{figure}

We can also plot a map of the patterns and their frequencies.
For instance, figure 2 illustrates different ways to plot all the patterns with  frequency of 50\% or less.

\begin{figure}
<<fig=TRUE>>=
par(mfrow=c(2, 2))
patternMap(estimates[[1]],
           maxFreq=0.5,
           main='Estimated frequencies')
patternMap(estimates[[1]],
           estimatedDistribution=FALSE,
           maxFreq=0.5,
           topDown=FALSE,
           main='Observed frequencies')
patternMap(estimates[[1]],
           maxFreq=0.5,
           methCol=colorRampPalette(c('red', 'blue')),
           unMethCol='lightgrey',
           main='Estimated frequencies')
patternMap(estimates[[1]],
           estimatedDistribution=FALSE,
           maxFreq=0.5,
           methCol=c('bisque4', 'azure4'),
           unMethCol=c('beige', 'azure'),
           main='Observed frequencies')
@
\caption{Different ways to plot the estimated frequencies with \texttt{patternMap}}
\end{figure}

\begin{thebibliography}{}
\bibitem{Lin05}
Lin, P., For\^et, S., Wilson, S.R.\ and Burden, C.J., {\it Estimation of the methylation pattern distribution from deep sequencing data.} BMC Bioinformatics 2015, 16:145  doi:10.1186/s12859-015-0600-6
\end{thebibliography}

\end{document}

\name{plotPatterns}
\alias{plotPatterns}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
  Plot methylation pattern distribution
}
\description{
  Plot the observed distribution and the estimated distribution of the methylation patterns
}
\usage{
  plotPatterns(compareData, yLimit1=NULL, yLimit2=NULL)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{compareData}{
    data frame, obtained from the output of the function \code{\link{estimatePatterns}}
  }
  \item{yLimit1}{
    upper limit of y-axis on left hand scale of the first graph. If NULL, defaults to show all patterns
  }
  \item{yLimit2}{
    upper limit of y-axis on left hand scale of the second graph. If NULL, defaults to show most patterns
  }
}
\details{
	The two graphs in the output plot are the same but have different ranges. 
	The parameters yLimit1 and yLimit2 control the range of the y_axis on the plots produced.
}
\value{
	A plot that compares the observed read distribution with the estimated distribution. 
}

\author{
  Peijie Lin, Sylvain Foret, Conrad Burden
}


%% ~Make other sections like Warning with \section{Warning }{....} ~


\examples{
  data(patternsExample)
  estimates <- estimatePatterns(patternsExample, 
                                epsilon=0.02, 
                                eta=0.01)
  plotPatterns(estimates[[1]])
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
% \keyword{ ~kwd1 }
% \keyword{ ~kwd2 }% __ONLY ONE__ keyword per line

% vim:ts=2:sw=2:sts=2:expandtab:

\name{MPFE-package}
\alias{MPFE-package}
\alias{MPFE}
\docType{package}
\title{
  MPFE
}

\description{
  Estimate distribution of methylation patterns from a table of counts from a
  bisulphite sequencing experiment given a non-conversion rate and sequencing
  error rate.
}

\details{
  \tabular{ll}{
    Package: \tab MPFE\cr
    Type: \tab Package\cr
    License: \tab GPL(>=3)\cr
  }
  The main component of this package is the function \code{\link{estimatePatterns}}, 
  which reads a table of read counts of bisulphite sequencing data for a given
  amplicon and generates a table and plot of the estimated distribution over
  methylation patterns.
}

\author{
  Peijie Lin, Sylvain Foret, Conrad Burden

  Maintainer: conrad.burden@anu.edu.au
}


\keyword{
  amplicon,
  bisulphite sequencing,
  bisufite sequencing,
  methylation
}


\examples{
  data(patternsExample)
  estimates <- estimatePatterns(patternsExample, epsilon=0.02, eta=0.01)
  estimates
  plotPatterns(estimates[[2]])
}

% vim:ts=2:sw=2:sts=2:expandtab:

\name{estimatePatterns}
\alias{estimatePatterns}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
  Estimate distribution of methylation patterns
}
\description{
  Estimate distribution of methylation patterns from a table of counts from a
  bisulphite sequencing experiment given a non-conversion rate and a sequencing
  error rate.
}
\usage{
  estimatePatterns(patternCounts,
                   epsilon=0,
                   eta=0,
                   column=NULL,
                   fast=TRUE,
                   steps=20000,
                   reltol=1e-12)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{patternCounts}{
    data frame with methylation patterns in first column and pattern counts in
    subsequent columns.
  }
  \item{epsilon}{
    non-converson rate, a value between 0 and 1.
  }
  \item{eta}{
    error rate, either a vector of numbers between 0 and 1 of length equal to
    the number of CpG sites or a single value between 0 and 1 for a single error
    rate across all sites.
  }
  \item{column}{
    a vector that specifies the indices of the columns of `patternCounts' to process. 
    Its entries are integer values from 1
    to the number of pattern counts columns in `patternCounts'.  
    If NULL, defaults to all columns.
  }
  \item{fast}{
    logical, if TRUE, fast version implemented (default).
  }
  \item{steps}{
    number of steps for the optimiser, passed to \code{\link{constrOptim}}.
    If NULL, defaults to 20000 steps.
  }
  \item{reltol}{
    relative tolerance for the optimiser, passed to \code{\link{constrOptim}}.
    If NULL, defaults to 1e-12.
  }
}

\value{
 The function returns a list of data frames.

The data frames contain the following columns:
  \item{pattern}{
    the list of input patterns (factor)
  }
  \item{coverage}{
    the number of reads for each pattern (integer)
  }
  \item{observedDistribution}{
    the observed frequencies of each pattern (numeric)
  }
  \item{estimatedDistribution}{
    the estimated frequencies (numeric)
  }
  \item{spurious}{
    indicates whether the patterns are real or spurious (logical)
  }
}

\author{
  Peijie Lin, Sylvain Foret, Conrad Burden
}


%% ~Make other sections like Warning with \section{Warning }{....} ~


\examples{
  data(patternsExample)
  estimatePatterns(patternsExample, 
                   epsilon=0.02, 
                   eta=0.01)
  estimatePatterns(patternsExample, 
                   epsilon=0.01, 
                   eta=c(0.015, 0.01, 0.01, 0.01, 0.015),
                   column=2)
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
% \keyword{ ~kwd1 }
% \keyword{ ~kwd2 }% __ONLY ONE__ keyword per line

% vim:ts=2:sw=2:sts=2:expandtab:

\name{patternMap}
\alias{patternMap}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
  Plot a representation of the patterns and their frequencies
}
\description{
  Plot the observed distribution and the estimated distribution of the methylation patterns
}
\usage{
  patternMap(patterns,
             minFreq=0,
             maxFreq=1,
             noSpurious=TRUE,
             estimatedDistribution=TRUE,
             topDown=TRUE,
             allTicks=FALSE,
             methCol='black',
             unMethCol='white',
             ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{patterns}{
    A data frame obtained from the output of the function \code{\link{estimatePatterns}}.
  }
  \item{minFreq}{
    Only plot patterns with at least \code{minFreq} frequency.
  }
  \item{maxFreq}{
    Only plot patterns with more \code{maxFreq} frequency or more.
  }
  \item{noSpurious}{
    Don't plot spurious patterns (only relevant if \code{estimatedDistribution} is \code{FALSE}).
  }
  \item{estimatedDistribution}{
    Use the frequencies from the estimated distribution. If \code{FALSE}, use the observed distribution.
  }
  \item{topDown}{
    Put the most abundant patterns at the top. If \code{FALSE} the most abundant patterns are at the bottom.
  }
  \item{allTicks}{
    Draw a tick under every position.
  }
  \item{methCol}{
    The colour for the methylated positions. Can be a single colour, a vector of colours (recycled), or a function (for instance from \code{\link{colorRampPalette}}).
  }
  \item{unMethCol}{
    As \code{methCol} but for un-methylated positions.
  }
  \item{...}{
    Other  arguments passed to \code{\link{plot}}
  }
}
\details{
	This function draws a map of the different pattern and their frequencies based on the values returned by \code{\link{estimatePatterns}}.
}

%% \value{
%%	A plot that compares the observed read distribution with the estimated distribution. 
%% }

\author{
  Peijie Lin, Sylvain Foret, Conrad Burden
}


%% ~Make other sections like Warning with \section{Warning }{....} ~


\examples{
  data(patternsExample)
  estimates <- estimatePatterns(patternsExample, 
                                epsilon=0.02, 
                                eta=0.01)
  patternMap(estimates[[1]])
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
% \keyword{ ~kwd1 }
% \keyword{ ~kwd2 }% __ONLY ONE__ keyword per line

% vim:ts=2:sw=2:sts=2:expandtab:

\name{patternsExample}
\alias{patternsExample}
\docType{data}
\title{patternsExample}
\description{
   A data frame which contains a column of methylation patterns and two columns
   of counts. This data was obtained as described in 
   Lyko, F., Forest, S., Kucharski, R., Wolf, S., Falckenhayn, C., 
   and Maleszka, R. (2010). The honey bee epigenomes: differential methylation of brain DNA in 
   queens and workers. PLoS Biol, 8(11), e1000506.
}
\usage{data(patternsExample)}
\format{
  This data frame contains the following columns:
    \describe{
      \item{mPattern}{methylation patterns}
      \item{k1}{first column of counts}
      \item{k2}{second column of counts}
    }
}

% vim:ts=2:sw=2:sts=2:expandtab:
